#include <vcl.h>
#pragma hdrstop
#include "UFormFind.h"
#include "UFormMessage.h"
#pragma package(smart_init)
#pragma resource "*.dfm"

TFormFind *FormFind;

// ===================================================================== //
__fastcall TFormFind::TFormFind(TComponent* Owner, TmsSearchNodeParams* ASearchNodeParams,
  int LangID) : TForm(Owner)
{
  FSearchNodeParams = ASearchNodeParams;
  FLangID = LangID;
}

// ===================================================================== //
void __fastcall TFormFind::FormCreate(TObject *Sender)
{
  if (FLangID == 0)
  {
    Caption                       = "Find Node";
    labelNodeName->Caption        = "Node name";
    checkMatchCase->Caption       = "Match case";
    checkPartialStrMatch->Caption = "Partial string match";
    btnFindNext->Caption          = "Find";
    btnClose->Caption             = "Close";
    GroupBoxDirection->Caption    = "Direction";
    RBtnBackward->Caption         = "Backward";
    RBtnForward->Caption          = "Forward";
  }
  else
  {
    Caption                       = " ";
    labelNodeName->Caption        = " ";
    checkMatchCase->Caption       = " ";
    checkPartialStrMatch->Caption = " ";
    btnFindNext->Caption          = "";
    btnClose->Caption             = "";
    GroupBoxDirection->Caption    = "";
    RBtnBackward->Caption         = "";
    RBtnForward->Caption          = "";
  }

  editNodeName->Text = FSearchNodeParams->Text;
  checkMatchCase->Checked = FSearchNodeParams->MatchCase;
  checkPartialStrMatch->Checked = FSearchNodeParams->PartialStringMatch;
  RBtnBackward->Checked = (FSearchNodeParams->Direction == sdBackward);
}

// ===================================================================== //
void __fastcall TFormFind::btnFindNextClick(TObject *Sender)
{
  if (editNodeName->Text != "")
  {
    FSearchNodeParams->Text = editNodeName->Text;
    FSearchNodeParams->MatchCase = checkMatchCase->Checked;
    FSearchNodeParams->PartialStringMatch = checkPartialStrMatch->Checked;
    if (RBtnBackward->Checked)
      FSearchNodeParams->Direction = sdBackward;
    else
      FSearchNodeParams->Direction = sdForward;
    SendMessage(Application->MainForm->Handle, SM_FIND_NEXT, 0, 0);  
  }
  else
  {
    CreateMessageDlg("Enter the node name for the search!", mtWarning);
    editNodeName->SetFocus();
  }
}

