#ifndef UFormMainH
#define UFormMainH
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ImgList.hpp>
#include <ActnList.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include "msBaseTreeView.hpp"
#include "msTreeView.hpp"
#include "UResource.h"

class TFormMain : public TForm
{
__published:	// IDE-managed Components
  TStatusBar *StatusBar;
  TSaveDialog *SaveDlg;
  TOpenDialog *OpenDlg;
  TImageList *ImgList_Tree;
  TImageList *ImgList_mMenu;
  TActionList *ActionList;
  TAction *aTools_AutoDrag;
  TAction *aTools_AutoSort;
  TAction *aEditAdd;
  TAction *aEditDelete;
  TAction *aEditCut;
  TAction *aFileExit;
  TAction *aEditCopy;
  TAction *aEditPaste;
  TAction *aEditRename;
  TAction *aHelpAbout;
  TAction *aLangEng;
  TAction *aLangRus;
  TAction *aTools_SortAZ;
  TAction *aTools_SortZA;
  TAction *aTools_ReadOnly;
  TAction *aEditFind;
  TAction *aFileLoad;
  TAction *aFileSave;
  TAction *aFileFullExpand;
  TAction *aFileFullCollapse;
  TMainMenu *mMenu;
  TMenuItem *mMenu_File;
  TMenuItem *mMenu_FileLoad;
  TMenuItem *mMenu_FileSave;
  TMenuItem *mMenu_FileN1;
  TMenuItem *mMenu_FileFullExpand;
  TMenuItem *mMenu_FileFullCollapse;
  TMenuItem *mMenu_FileN2;
  TMenuItem *mMenu_FileExit;
  TMenuItem *mMenu_Edit;
  TMenuItem *mMenu_EditAdd;
  TMenuItem *mMenu_EditDelete;
  TMenuItem *mMenu_EditN1;
  TMenuItem *mMenu_EditCut;
  TMenuItem *mMenu_EditCopy;
  TMenuItem *mMenu_EditPaste;
  TMenuItem *mMenu_EditN2;
  TMenuItem *mMenu_EditRename;
  TMenuItem *mMenu_EditN3;
  TMenuItem *mMenu_EditFind;
  TMenuItem *mMenu_Tools;
  TMenuItem *mMenu_ToolsAutoDrag;
  TMenuItem *mMenu_ToolsAutoSort;
  TMenuItem *mMenu_ToolsN1;
  TMenuItem *mMenu_ToolsSortAZ;
  TMenuItem *mMenu_ToolsSortZA;
  TMenuItem *mMenu_ToolsN2;
  TMenuItem *mMenu_ToolsReadOnly;
  TMenuItem *mMenu_Lang;
  TMenuItem *mMenu_LangEng;
  TMenuItem *mMenu_LangRus;
  TMenuItem *mMenu_Help;
  TMenuItem *mMenu_About;
  TPopupMenu *pMenu;
  TMenuItem *pMenu_Add;
  TMenuItem *pMenu_Delete;
  TMenuItem *pMenu_N1;
  TMenuItem *pMenu_Cut;
  TMenuItem *pMenu_Copy;
  TMenuItem *pMenu_Paste;
  TMenuItem *pMenu_N2;
  TMenuItem *pMenu_Rename;
  TToolBar *ToolBar;
  TToolButton *ToolButton4;
  TToolButton *ToolButton1;
  TToolButton *ToolButton2;
  TToolButton *ToolButton5;
  TToolButton *ToolButton6;
  TToolButton *ToolButton7;
  TToolButton *ToolButton8;
  TToolButton *ToolButton10;
  TToolButton *ToolButton9;
  TToolButton *ToolButton3;
  TToolButton *ToolButton11;
  TToolButton *ToolButton12;
  TToolButton *ToolButton16;
  TToolButton *ToolButton14;
  TToolButton *ToolButton13;
  TmsTreeView *msTV;
  void __fastcall aFileLoadExecute(TObject *Sender);
  void __fastcall aFileSaveExecute(TObject *Sender);
  void __fastcall aFileFullExpandExecute(TObject *Sender);
  void __fastcall aFileFullCollapseExecute(TObject *Sender);
  void __fastcall aEditAddExecute(TObject *Sender);
  void __fastcall aEditDeleteExecute(TObject *Sender);
  void __fastcall aEditCutExecute(TObject *Sender);
  void __fastcall aEditCopyExecute(TObject *Sender);
  void __fastcall aEditPasteExecute(TObject *Sender);
  void __fastcall aEditRenameExecute(TObject *Sender);
  void __fastcall aEditFindExecute(TObject *Sender);
  void __fastcall aTools_AutoDragExecute(TObject *Sender);
  void __fastcall aTools_AutoSortExecute(TObject *Sender);
  void __fastcall aTools_SortAZExecute(TObject *Sender);
  void __fastcall aTools_SortZAExecute(TObject *Sender);
  void __fastcall aTools_ReadOnlyExecute(TObject *Sender);
  void __fastcall aLangEngExecute(TObject *Sender);
  void __fastcall aHelpAboutExecute(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall aFileExitExecute(TObject *Sender);
  void __fastcall msTVBeforeSearchNode(TObject *Sender,
          TmsSearchNodeParams &SearchNodeParams);
  void __fastcall msTVMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall msTVProcessError(TObject *Sender, AnsiString Msg);
protected:
  MESSAGE __fastcall smFindNext(TMessage& Msg);
  BEGIN_MESSAGE_MAP
    VCL_MESSAGE_HANDLER(SM_FIND_NEXT, TMessage, smFindNext);
  END_MESSAGE_MAP(TForm);
private:	// User declarations
  int FLangID;
  void __fastcall SetLanguage();
public:		// User declarations
  __fastcall TFormMain(TComponent* Owner);
};
extern PACKAGE TFormMain *FormMain;

#endif
