// ****************************************** //
// *                                        * //
// *  TmsDBTreeView demo project            * //
// *                                        * //
// *  Copyright (c) mSunSoftware. 2006.     * //
// *  All rights reserved.                  * //
// *  Web:     http://www.msunsoftware.com  * //
// *  E-mail:  support@msunsoftware.com     * //
// *                                        * //
// ****************************************** //

unit UFormMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, ActnList, Menus, StdCtrls, DBCtrls,
  DB, ADODB, ExtCtrls, Grids, DBGrids, UResource, msTVResource,
  msBaseTreeView, msTreeView, msDBTreeView;

type
  TFormMain = class(TForm)
    mMenu: TMainMenu;
    mMenu_File: TMenuItem;
    mMenu_FileExit: TMenuItem;
    mMenu_Edit: TMenuItem;
    mMenu_EditAdd: TMenuItem;
    mMenu_EditDelete: TMenuItem;
    mMenu_EditN1: TMenuItem;
    mMenu_EditCut: TMenuItem;
    mMenu_EditCopy: TMenuItem;
    mMenu_EditPaste: TMenuItem;
    mMenu_EditN2: TMenuItem;
    mMenu_EditFind: TMenuItem;
    mMenu_Lang: TMenuItem;
    mMenu_LangEng: TMenuItem;
    mMenu_LangRus: TMenuItem;
    mMenu_Help: TMenuItem;
    mMenu_About: TMenuItem;
    ActionList: TActionList;
    aEditAdd: TAction;
    aEditDelete: TAction;
    aEditCut: TAction;
    aFileExit: TAction;
    aEditCopy: TAction;
    aEditPaste: TAction;
    aHelpAbout: TAction;
    aLangEng: TAction;
    aLangRus: TAction;
    aTools_SortAZ: TAction;
    aTools_SortZA: TAction;
    aEditFind: TAction;
    ImgList_mMenu: TImageList;
    ToolBar: TToolBar;
    ToolButton4: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton3: TToolButton;
    ToolButton9: TToolButton;
    ToolButton13: TToolButton;
    mMenu_Tools: TMenuItem;
    mMenu_ToolsSortAZ: TMenuItem;
    mMenu_ToolsSortZA: TMenuItem;
    StatusBar: TStatusBar;
    ImgList_Tree: TImageList;
    mMenu_ToolsN2: TMenuItem;
    aTools_ReadOnly: TAction;
    mMenu_ToolsReadOnly: TMenuItem;
    ToolButton14: TToolButton;
    ToolButton16: TToolButton;
    mMenu_ToolsAutoDrag: TMenuItem;
    mMenu_ToolsAutoSort: TMenuItem;
    mMenu_ToolsN1: TMenuItem;
    aTools_AutoDrag: TAction;
    aTools_AutoSort: TAction;
    pMenu: TPopupMenu;
    pMenu_Add: TMenuItem;
    pMenu_Delete: TMenuItem;
    pMenu_N1: TMenuItem;
    pMenu_Cut: TMenuItem;
    pMenu_Copy: TMenuItem;
    pMenu_Paste: TMenuItem;
    pMenu_N2: TMenuItem;
    aEditRename: TAction;
    mMenu_EditN3: TMenuItem;
    mMenu_EditRename: TMenuItem;
    pMenu_Rename: TMenuItem;
    aFileLoad: TAction;
    aFileSave: TAction;
    aFileFullExpand: TAction;
    aFileFullCollapse: TAction;
    mMenu_FileN1: TMenuItem;
    mMenu_FileLoad: TMenuItem;
    mMenu_FileSave: TMenuItem;
    mMenu_FileFullExpand: TMenuItem;
    mMenu_FileFullCollapse: TMenuItem;
    mMenu_FileN2: TMenuItem;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    DataSource: TDataSource;
    ADOConnection: TADOConnection;
    ADODataSet: TADODataSet;
    aConnConnected: TAction;
    mMenu_Conn: TMenuItem;
    mMenu_ConnConnected: TMenuItem;
    Panel_Left: TPanel;
    msTV: TmsDBTreeView;
    Panel_Main: TPanel;
    gBox_Data: TGroupBox;
    DBRichEdit: TDBRichEdit;
    gBox_DataSet: TGroupBox;
    DBGrid: TDBGrid;
    DBNavigator: TDBNavigator;
    procedure FormCreate(Sender: TObject);
    procedure aFileExitExecute(Sender: TObject);
    procedure aEditAddExecute(Sender: TObject);
    procedure aEditDeleteExecute(Sender: TObject);
    procedure aEditCutExecute(Sender: TObject);
    procedure aEditCopyExecute(Sender: TObject);
    procedure aEditPasteExecute(Sender: TObject);
    procedure aEditFindExecute(Sender: TObject);
    procedure aTools_SortAZExecute(Sender: TObject);
    procedure aTools_SortZAExecute(Sender: TObject);
    procedure aLangEngExecute(Sender: TObject);
    procedure aHelpAboutExecute(Sender: TObject);
    procedure aTools_ReadOnlyExecute(Sender: TObject);
    procedure aTools_AutoDragExecute(Sender: TObject);
    procedure aTools_AutoSortExecute(Sender: TObject);
    procedure msTVBeforeSearchNode(Sender: TObject;
      var SearchNodeParams: TmsSearchNodeParams);
    procedure aEditRenameExecute(Sender: TObject);
    procedure msTVProcessError(Sender: TObject; Msg: string);
    procedure aFileLoadExecute(Sender: TObject);
    procedure aFileSaveExecute(Sender: TObject);
    procedure aFileFullExpandExecute(Sender: TObject);
    procedure aFileFullCollapseExecute(Sender: TObject);
    procedure msTVMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure aConnConnectedExecute(Sender: TObject);
    procedure Panel_MainResize(Sender: TObject);
    procedure ADODataSetAfterInsert(DataSet: TDataSet);
    procedure msTVCollapsed(Sender: TObject; Node: TmsBaseTreeNode);
    procedure msTVGetImageIndex(Sender: TObject; Node: TmsBaseTreeNode);
    procedure msTVGetSelectedIndex(Sender: TObject; Node: TmsBaseTreeNode);
  private
    FLangID: Integer;
    procedure SetConnection();
    procedure SetLanguage();
  protected
    procedure smFindNext(var Msg: TMessage); message SM_FIND_NEXT;
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses UFormFind, UFormMessage, UFormAbout;

{$R *.dfm}

// ===================================================================== //
procedure TFormMain.smFindNext(var Msg: TMessage);
var
  Node: TmsBaseTreeNode;
begin
  Node := msTV.FindNextNode();
  if (Node <> nil) then
    msTV.Selected := Node;
  Msg.Result := Integer(Node <> nil);

  if (Msg.Result = 0) then
    CreateMessageDlg('Search is completed!', mtInformation);
end;

// ===================================================================== //
procedure TFormMain.SetConnection();
const
  sConnStr: string      = 'Provider=%s;Data Provider=%s;Data Source=%s';
  sProvider: string     = 'MSDataShape.1';
  sDataProvider: string = 'Microsoft.Jet.OLEDB.4.0';
var
  sDataSource: string;
begin
  if (ADOConnection.Connected) then
    ADOConnection.Close();

  // Init the connection string
  sDataSource := ExtractFilePath(Application.ExeName) + 'Database.mdb';
  ADOConnection.ConnectionString := Format(sConnStr, [sProvider, sDataProvider, sDataSource]);
  ADODataSet.CommandText := Format('SELECT * FROM dbTable WHERE LangID=%d', [FLangID]);

  // Open connection
  try
    ADOConnection.Open();
    ADODataSet.Open();
    aConnConnected.Checked := true;
  except
    CreateMessageDlg('The database was not found or an error was fixed!', mtError);
    Application.Terminate(); // DB not found! - terminate the program
  end;
end;

// ===================================================================== //
procedure TFormMain.SetLanguage();
begin
  if (FLangID = 0) then begin
    mMenu_File.Caption         := 'File';
    aFileLoad.Caption          := 'Load Tree';
    aFileSave.Caption          := 'Save Tree';
    aFileFullExpand.Caption    := 'Full Expand';
    aFileFullCollapse.Caption  := 'Full Collapse';
    aFileExit.Caption          := 'Close';
    mMenu_Conn.Caption         := 'Connection';
    aConnConnected.Caption     := 'Connected';
    mMenu_Edit.Caption         := 'Edit';
    aEditAdd.Caption           := 'Add Node';
    aEditDelete.Caption        := 'Delete Node';
    aEditCut.Caption           := 'Cut';
    aEditCopy.Caption          := 'Copy';
    aEditPaste.Caption         := 'Paste';
    aEditRename.Caption        := 'Rename Node';
    aEditFind.Caption          := 'Find';
    mMenu_Tools.Caption        := 'Tools';
    aTools_AutoDrag.Caption    := 'Auto Drag';
    aTools_AutoSort.Caption    := 'Auto Sort';
    aTools_SortAZ.Caption      := 'Sort A-Z';
    aTools_SortZA.Caption      := 'Sort Z-A';
    aTools_ReadOnly.Caption    := 'Read Only';
    mMenu_Lang.Caption         := 'Language';
    aLangEng.Caption           := 'English';
    aLangRus.Caption           := 'Russian';
    mMenu_Help.Caption         := 'Help';
    aHelpAbout.Caption         := 'About';
    gBox_Data.Caption          := 'The Data of the field "Description"';
    gBox_DataSet.Caption       := 'DataSet';
  end
  else begin
    mMenu_File.Caption         := '';
    aFileLoad.Caption          := ' ';
    aFileSave.Caption          := ' ';
    aFileFullExpand.Caption    := '  ';
    aFileFullCollapse.Caption  := '  ';
    aFileExit.Caption          := '';
    mMenu_Conn.Caption         := '';
    aConnConnected.Caption     := '';
    mMenu_Edit.Caption         := '';
    aEditAdd.Caption           := ' ';
    aEditDelete.Caption        := ' ';
    aEditCut.Caption           := '';
    aEditCopy.Caption          := '';
    aEditPaste.Caption         := '';
    aEditRename.Caption        := ' ';
    aEditFind.Caption          := '';
    mMenu_Tools.Caption        := '';
    aTools_AutoDrag.Caption    := ' ';
    aTools_AutoSort.Caption    := ' ';
    aTools_SortAZ.Caption      := '  A  Z';
    aTools_SortZA.Caption      := '  Z  A';
    aTools_ReadOnly.Caption    := ' ';
    mMenu_Lang.Caption         := '';
    aLangEng.Caption           := '';
    aLangRus.Caption           := '';
    mMenu_Help.Caption         := '';
    aHelpAbout.Caption         := ' ';
    gBox_Data.Caption          := '  ""';
    gBox_DataSet.Caption       := ' ';
  end;
end;

// ===================================================================== //
procedure TFormMain.FormCreate(Sender: TObject);
begin
  FLangID := 0;
  // Open connection to database
  SetConnection();
  // Set language
  SetLanguage();

  // Init menu items
  aEditAdd.ShortCut    := msTV.TVShortCuts.scAddNode;
  aEditDelete.ShortCut := msTV.TVShortCuts.scDeleteNode;
  aEditCut.ShortCut    := msTV.TVShortCuts.scCutNode;
  aEditCopy.ShortCut   := msTV.TVShortCuts.scCopyNode;
  aEditPaste.ShortCut  := msTV.TVShortCuts.scPasteNode;
  aEditRename.ShortCut := msTV.TVShortCuts.scEditNode;
  aEditFind.ShortCut   := msTV.TVShortCuts.scFindNode;

  aConnConnected.Checked  := ADODataSet.Active;
  aTools_AutoDrag.Checked := msTV.TVOptions.AutoDrag;
  aTools_AutoSort.Checked := msTV.TVOptions.AutoSort;
  aTools_ReadOnly.Checked := msTV.ReadOnly;
  aLangEng.Checked := true;

  WindowState := wsMaximized;

  // Init TreeView
  msTV.SortTreeNodes(true);
end;

// ===================================================================== //
procedure TFormMain.aFileLoadExecute(Sender: TObject);
begin
  if ( OpenDlg.Execute() ) then
    msTV.LoadFromFile(OpenDlg.FileName);
end;

// ===================================================================== //
procedure TFormMain.aFileSaveExecute(Sender: TObject);
begin
  if ( SaveDlg.Execute() ) then
    msTV.SaveToFile(SaveDlg.FileName);
end;

// ===================================================================== //
procedure TFormMain.aFileFullExpandExecute(Sender: TObject);
begin
  msTV.Items.BeginUpdate();
  try
    msTV.FullExpand();
  finally
    msTV.Items.EndUpdate();
  end;
end;

// ===================================================================== //
procedure TFormMain.aFileFullCollapseExecute(Sender: TObject);
begin
  msTV.Items.BeginUpdate();
  try
    msTV.FullCollapse();
  finally
    msTV.Items.EndUpdate();
  end;
end;

// ===================================================================== //
procedure TFormMain.aFileExitExecute(Sender: TObject);
begin
  Close();
end;

// ===================================================================== //
procedure TFormMain.aConnConnectedExecute(Sender: TObject);
begin
  aConnConnected.Checked := not aConnConnected.Checked;
  if (aConnConnected.Checked) then
    SetConnection()
  else
    ADOConnection.Close();
end;

// ===================================================================== //
procedure TFormMain.aEditAddExecute(Sender: TObject);
begin
  if (not msTV.IsEditing()) then
    msTV.AddNode();
end;

// ===================================================================== //
procedure TFormMain.aEditDeleteExecute(Sender: TObject);
begin
  if (msTV.Focused and (not msTV.IsEditing())) then
    msTV.DeleteNode();
end;

// ===================================================================== //
procedure TFormMain.aEditCutExecute(Sender: TObject);
begin
  if (not msTV.IsEditing()) then
    msTV.CutNode();
end;

// ===================================================================== //
procedure TFormMain.aEditCopyExecute(Sender: TObject);
begin
  if (not msTV.IsEditing()) then
    msTV.CopyNode();
end;

// ===================================================================== //
procedure TFormMain.aEditPasteExecute(Sender: TObject);
begin
  if (not msTV.IsEditing()) then
    msTV.PasteNode();
end;

// ===================================================================== //
procedure TFormMain.aEditRenameExecute(Sender: TObject);
begin
  if (not msTV.IsEditing()) then
    msTV.EditNode();
end;

// ===================================================================== //
procedure TFormMain.aEditFindExecute(Sender: TObject);
begin
  if (not msTV.IsEditing()) then
    msTV.InitSearchParams();
end;

// ===================================================================== //
procedure TFormMain.aTools_AutoDragExecute(Sender: TObject);
begin
  aTools_AutoDrag.Checked := not aTools_AutoDrag.Checked;
  msTV.TVOptions.AutoDrag := aTools_AutoDrag.Checked;
end;

// ===================================================================== //
procedure TFormMain.aTools_AutoSortExecute(Sender: TObject);
begin
  aTools_AutoSort.Checked := not aTools_AutoSort.Checked;
  msTV.TVOptions.AutoSort := aTools_AutoSort.Checked;
end;

// ===================================================================== //
procedure TFormMain.aTools_SortAZExecute(Sender: TObject);
begin
  msTV.TVOptions.SortDirection := sdAlphabeticOrder;
end;

// ===================================================================== //
procedure TFormMain.aTools_SortZAExecute(Sender: TObject);
begin
  msTV.TVOptions.SortDirection := sdInvertedOrder;
end;

// ===================================================================== //
procedure TFormMain.aTools_ReadOnlyExecute(Sender: TObject);
begin
  aTools_ReadOnly.Checked := not aTools_ReadOnly.Checked;
  msTV.ReadOnly := aTools_ReadOnly.Checked;
end;

// ===================================================================== //
procedure TFormMain.aLangEngExecute(Sender: TObject);
var
  ID: Integer;
begin
  (Sender as TAction).Checked := true;
  ID := (Sender as TComponent).Tag;
  if (ID = 0) then // English
    aLangRus.Checked := false
  else             // Russian;
    aLangEng.Checked := false;

  // Set Language
  if (FLangID <> ID) then begin
    FLangID := ID;
    SetConnection();
    SetLanguage();
  end;
end;

// ===================================================================== //
procedure TFormMain.aHelpAboutExecute(Sender: TObject);
begin
  FormAbout := TFormAbout.Create(self);
  FormAbout.ShowModal();
  FormAbout.Release();
end;

// ===================================================================== //
procedure TFormMain.msTVProcessError(Sender: TObject; Msg: string);
begin
  CreateMessageDlg(Msg, mtWarning);
end;

// ===================================================================== //
procedure TFormMain.msTVBeforeSearchNode(Sender: TObject;
  var SearchNodeParams: TmsSearchNodeParams);
var
  Pos: TPoint;
begin
  FormFind := TFormFind.Create(Self, @SearchNodeParams, FLangID);
  Pos.X := ToolBar.Left + ToolBar.Width - FormFind.Width - 1;
  Pos.Y := ToolBar.Top + ToolBar.Height + 1;
  Pos := ClientToScreen(Pos);
  FormFind.Left := Pos.X;
  FormFind.Top := Pos.Y;
  FormFind.ShowModal();
  FormFind.Release();
end;

// ===================================================================== //
procedure TFormMain.msTVMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Node: TmsBaseTreeNode;
  Point: TPoint;
begin
  if (Button = mbRight) then begin
    Node := msTV.GetNodeAt(X, Y);
    if (Node <> nil) then begin
      msTV.Selected := Node;
      Point.X := X;
      Point.Y := Y;
      Point := msTV.ClientToScreen(Point);
      msTV.PopupMenu.Popup(Point.X, Point.Y);
    end;
  end;
end;

// ===================================================================== //
procedure TFormMain.msTVCollapsed(Sender: TObject; Node: TmsBaseTreeNode);
begin
  msTV.Invalidate();
end;

// ===================================================================== //
procedure TFormMain.msTVGetImageIndex(Sender: TObject;
  Node: TmsBaseTreeNode);
begin
  if (not Node.HasChildren) then
    Node.ImageIndex := 0
  else begin
    if (not Node.Expanded) then
      Node.ImageIndex := 1
    else
      Node.ImageIndex := 2;
  end;
end;

// ===================================================================== //
procedure TFormMain.msTVGetSelectedIndex(Sender: TObject;
  Node: TmsBaseTreeNode);
begin
 Node.SelectedIndex := Node.ImageIndex;
end;

// ===================================================================== //
procedure TFormMain.Panel_MainResize(Sender: TObject);
var
  i: Integer;
  ColumnsWidth: Integer;
begin
  // GroupBox_DataSet height
  gBox_DataSet.Height := Panel_Main.ClientHeight div 2;

  // DBGrid width
  ColumnsWidth := 0;
  for i := 0 to DBGrid.Columns.Count - 1 do
    if (i <> 3) then // 'Text' field
      ColumnsWidth := ColumnsWidth + DBGrid.Columns.Items[i].Width;
  DBGrid.Columns.Items[3].Width := DBGrid.ClientWidth - ColumnsWidth - 20;
end;

// ===================================================================== //
procedure TFormMain.ADODataSetAfterInsert(DataSet: TDataSet);
begin
  DataSource.DataSet.FieldByName('LangID').AsInteger := FLangID;
end;

end.
