unit UFormFind;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, UResource, msTVResource, msTreeView;

type
  TFormFind = class(TForm)
    btnFindNext: TButton;
    btnClose: TButton;
    Panel: TPanel;
    labelNodeName: TLabel;
    editNodeName: TEdit;
    GroupBoxDirection: TGroupBox;
    RBtnBackward: TRadioButton;
    RBtnForward: TRadioButton;
    checkMatchCase: TCheckBox;
    checkPartialStrMatch: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btnFindNextClick(Sender: TObject);
  private
    FSearchNodeParams: PmsSearchNodeParams;
    FLangID: Integer;
  public
    constructor Create(AOwner: TComponent; ASearchNodeParams:
      PmsSearchNodeParams; LangID: Integer); reintroduce; overload;
  end;

var
  FormFind: TFormFind;

implementation

{$R *.dfm}

uses UFormMessage;

// ===================================================================== //
constructor TFormFind.Create(AOwner: TComponent; ASearchNodeParams: PmsSearchNodeParams;
  LangID: Integer);
begin
  inherited Create(AOwner);

  FSearchNodeParams := ASearchNodeParams;
  FLangID := LangID;
end;

// ===================================================================== //
procedure TFormFind.FormCreate(Sender: TObject);
begin
  if (FLangID = 0) then begin
    Caption                      := 'Find Node';
    labelNodeName.Caption        := 'Node name';
    checkMatchCase.Caption       := 'Match case';
    checkPartialStrMatch.Caption := 'Partial string match';
    btnFindNext.Caption          := 'Find';
    btnClose.Caption             := 'Close';
    GroupBoxDirection.Caption    := 'Direction';
    RBtnBackward.Caption         := 'Backward';
    RBtnForward.Caption          := 'Forward';
  end
  else begin
    Caption                      := ' ';
    labelNodeName.Caption        := ' ';
    checkMatchCase.Caption       := ' ';
    checkPartialStrMatch.Caption := ' ';
    btnFindNext.Caption          := '';
    btnClose.Caption             := '';
    GroupBoxDirection.Caption    := '';
    RBtnBackward.Caption         := '';
    RBtnForward.Caption          := '';
  end;

  editNodeName.Text := FSearchNodeParams.Text;
  checkMatchCase.Checked := FSearchNodeParams.MatchCase;
  checkPartialStrMatch.Checked := FSearchNodeParams.PartialStringMatch;
  RBtnBackward.Checked := (FSearchNodeParams.Direction = sdBackward);
end;

// ===================================================================== //
procedure TFormFind.btnFindNextClick(Sender: TObject);
begin
  if (editNodeName.Text <> '') then begin
    FSearchNodeParams.Text := editNodeName.Text;
    FSearchNodeParams.MatchCase := checkMatchCase.Checked;
    FSearchNodeParams.PartialStringMatch := checkPartialStrMatch.Checked;
    if (RBtnBackward.Checked) then
      FSearchNodeParams.Direction := sdBackward
    else
      FSearchNodeParams.Direction := sdForward;
    SendMessage(Application.MainForm.Handle, SM_FIND_NEXT, 0, 0);
  end
  else begin
    CreateMessageDlg('Enter the node name for the search!', mtWarning);
    editNodeName.SetFocus();
  end;
end;

end.
