// ****************************************** //
// *                                        * //
// *  TmsTreeView demo project              * //
// *                                        * //
// *  Copyright (c) mSunSoftware. 2006.     * //
// *  All rights reserved.                  * //
// *  Web:     http://www.msunsoftware.com  * //
// *  E-mail:  support@msunsoftware.com     * //
// *                                        * //
// ****************************************** //

unit UFormMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, ActnList, Menus, StdCtrls, ExtCtrls,
  UResource, msTVResource, msBaseTreeView, msTreeView, msDBTreeView;

type
  TFormMain = class(TForm)
    mMenu: TMainMenu;
    mMenu_File: TMenuItem;
    mMenu_FileExit: TMenuItem;
    mMenu_Edit: TMenuItem;
    mMenu_EditAdd: TMenuItem;
    mMenu_EditDelete: TMenuItem;
    mMenu_EditN1: TMenuItem;
    mMenu_EditCut: TMenuItem;
    mMenu_EditCopy: TMenuItem;
    mMenu_EditPaste: TMenuItem;
    mMenu_EditN2: TMenuItem;
    mMenu_EditFind: TMenuItem;
    mMenu_Lang: TMenuItem;
    mMenu_LangEng: TMenuItem;
    mMenu_LangRus: TMenuItem;
    mMenu_Help: TMenuItem;
    mMenu_About: TMenuItem;
    ActionList: TActionList;
    aEditAdd: TAction;
    aEditDelete: TAction;
    aEditCut: TAction;
    aFileExit: TAction;
    aEditCopy: TAction;
    aEditPaste: TAction;
    aHelpAbout: TAction;
    aLangEng: TAction;
    aLangRus: TAction;
    aTools_SortAZ: TAction;
    aTools_SortZA: TAction;
    aEditFind: TAction;
    ImgList_mMenu: TImageList;
    ToolBar: TToolBar;
    ToolButton4: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton3: TToolButton;
    ToolButton9: TToolButton;
    ToolButton13: TToolButton;
    mMenu_Tools: TMenuItem;
    mMenu_ToolsSortAZ: TMenuItem;
    mMenu_ToolsSortZA: TMenuItem;
    StatusBar: TStatusBar;
    ImgList_Tree: TImageList;
    mMenu_ToolsN2: TMenuItem;
    aTools_ReadOnly: TAction;
    mMenu_ToolsReadOnly: TMenuItem;
    ToolButton14: TToolButton;
    ToolButton16: TToolButton;
    msTV: TmsTreeView;
    mMenu_ToolsAutoDrag: TMenuItem;
    mMenu_ToolsAutoSort: TMenuItem;
    mMenu_ToolsN1: TMenuItem;
    aTools_AutoDrag: TAction;
    aTools_AutoSort: TAction;
    pMenu: TPopupMenu;
    pMenu_Add: TMenuItem;
    pMenu_Delete: TMenuItem;
    pMenu_N1: TMenuItem;
    pMenu_Cut: TMenuItem;
    pMenu_Copy: TMenuItem;
    pMenu_Paste: TMenuItem;
    pMenu_N2: TMenuItem;
    aEditRename: TAction;
    mMenu_EditN3: TMenuItem;
    mMenu_EditRename: TMenuItem;
    pMenu_Rename: TMenuItem;
    aFileLoad: TAction;
    aFileSave: TAction;
    aFileFullExpand: TAction;
    aFileFullCollapse: TAction;
    mMenu_FileN1: TMenuItem;
    mMenu_FileLoad: TMenuItem;
    mMenu_FileSave: TMenuItem;
    mMenu_FileFullExpand: TMenuItem;
    mMenu_FileFullCollapse: TMenuItem;
    mMenu_FileN2: TMenuItem;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure aFileExitExecute(Sender: TObject);
    procedure aEditAddExecute(Sender: TObject);
    procedure aEditDeleteExecute(Sender: TObject);
    procedure aEditCutExecute(Sender: TObject);
    procedure aEditCopyExecute(Sender: TObject);
    procedure aEditPasteExecute(Sender: TObject);
    procedure aEditFindExecute(Sender: TObject);
    procedure aTools_SortAZExecute(Sender: TObject);
    procedure aTools_SortZAExecute(Sender: TObject);
    procedure aLangEngExecute(Sender: TObject);
    procedure aHelpAboutExecute(Sender: TObject);
    procedure aTools_ReadOnlyExecute(Sender: TObject);
    procedure aTools_AutoDragExecute(Sender: TObject);
    procedure aTools_AutoSortExecute(Sender: TObject);
    procedure aFileLoadExecute(Sender: TObject);
    procedure aFileSaveExecute(Sender: TObject);
    procedure aFileFullExpandExecute(Sender: TObject);
    procedure aFileFullCollapseExecute(Sender: TObject);
    procedure aEditRenameExecute(Sender: TObject);
    procedure msTVBeforeSearchNode(Sender: TObject;
      var SearchNodeParams: TmsSearchNodeParams);
    procedure msTVProcessError(Sender: TObject; Msg: string);
    procedure msTVMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ActionListExecute(Action: TBasicAction;
      var Handled: Boolean);
  private
    FLangID: Integer;
    procedure SetLanguage();
  protected
    procedure smFindNext(var Msg: TMessage); message SM_FIND_NEXT;
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses UFormFind, UFormMessage, UFormAbout;

{$R *.dfm}

// ===================================================================== //
procedure TFormMain.smFindNext(var Msg: TMessage);
var
  Node: TmsBaseTreeNode;
begin
  Node := msTV.FindNextNode();
  if (Node <> nil) then
    msTV.Selected := Node;
  Msg.Result := Integer(Node <> nil);

  if (Msg.Result = 0) then
    CreateMessageDlg('Search is completed!', mtInformation);
end;

// ===================================================================== //
procedure TFormMain.SetLanguage();
begin
  if (FLangID = 0) then begin
    mMenu_File.Caption         := 'File';
    aFileLoad.Caption          := 'Load Tree';
    aFileSave.Caption          := 'Save Tree';
    aFileFullExpand.Caption    := 'Full Expand';
    aFileFullCollapse.Caption  := 'Full Collapse';
    aFileExit.Caption          := 'Close';
    mMenu_Edit.Caption         := 'Edit';
    aEditAdd.Caption           := 'Add Node';
    aEditDelete.Caption        := 'Delete Node';
    aEditCut.Caption           := 'Cut';
    aEditCopy.Caption          := 'Copy';
    aEditPaste.Caption         := 'Paste';
    aEditRename.Caption        := 'Rename Node';
    aEditFind.Caption          := 'Find';
    mMenu_Tools.Caption        := 'Tools';
    aTools_AutoDrag.Caption    := 'Auto Drag';
    aTools_AutoSort.Caption    := 'Auto Sort';
    aTools_SortAZ.Caption      := 'Sort A-Z';
    aTools_SortZA.Caption      := 'Sort Z-A';
    aTools_ReadOnly.Caption    := 'Read Only';
    mMenu_Lang.Caption         := 'Language';
    aLangEng.Caption           := 'English';
    aLangRus.Caption           := 'Russian';
    mMenu_Help.Caption         := 'Help';
    aHelpAbout.Caption         := 'About';
  end
  else begin
    mMenu_File.Caption         := '';
    aFileLoad.Caption          := ' ';
    aFileSave.Caption          := ' ';
    aFileFullExpand.Caption    := '  ';
    aFileFullCollapse.Caption  := '  ';
    aFileExit.Caption          := '';
    mMenu_Edit.Caption         := '';
    aEditAdd.Caption           := ' ';
    aEditDelete.Caption        := ' ';
    aEditCut.Caption           := '';
    aEditCopy.Caption          := '';
    aEditPaste.Caption         := '';
    aEditRename.Caption        := ' ';
    aEditFind.Caption          := '';
    mMenu_Tools.Caption        := '';
    aTools_AutoDrag.Caption    := ' ';
    aTools_AutoSort.Caption    := ' ';
    aTools_SortAZ.Caption      := '  A  Z';
    aTools_SortZA.Caption      := '  Z  A';
    aTools_ReadOnly.Caption    := ' ';
    mMenu_Lang.Caption         := '';
    aLangEng.Caption           := '';
    aLangRus.Caption           := '';
    mMenu_Help.Caption         := '';
    aHelpAbout.Caption         := ' ';
  end;
end;

// ===================================================================== //
procedure TFormMain.FormCreate(Sender: TObject);
begin
  aEditAdd.ShortCut    := msTV.TVShortCuts.scAddNode;
  aEditDelete.ShortCut := msTV.TVShortCuts.scDeleteNode;
  aEditCut.ShortCut    := msTV.TVShortCuts.scCutNode;
  aEditCopy.ShortCut   := msTV.TVShortCuts.scCopyNode;
  aEditPaste.ShortCut  := msTV.TVShortCuts.scPasteNode;
  aEditRename.ShortCut := msTV.TVShortCuts.scEditNode;
  aEditFind.ShortCut   := msTV.TVShortCuts.scFindNode;

  aTools_AutoDrag.Checked := msTV.TVOptions.AutoDrag;
  aTools_AutoSort.Checked := msTV.TVOptions.AutoSort;
  aTools_ReadOnly.Checked := msTV.ReadOnly;
  aLangEng.Checked := true;

  FLangID := 0;
  SetLanguage();

  msTV.SortTreeNodes(true);
end;

// ===================================================================== //
procedure TFormMain.aFileLoadExecute(Sender: TObject);
begin
  if ( OpenDlg.Execute() ) then
    msTV.LoadFromFile(OpenDlg.FileName);
end;

// ===================================================================== //
procedure TFormMain.aFileSaveExecute(Sender: TObject);
begin
  if ( SaveDlg.Execute() ) then
    msTV.SaveToFile(SaveDlg.FileName);
end;

// ===================================================================== //
procedure TFormMain.aFileFullExpandExecute(Sender: TObject);
begin
  msTV.Items.BeginUpdate();
  try
    msTV.FullExpand();
  finally
    msTV.Items.EndUpdate();
  end;
end;

// ===================================================================== //
procedure TFormMain.aFileFullCollapseExecute(Sender: TObject);
begin
  msTV.Items.BeginUpdate();
  try
    msTV.FullCollapse();
  finally
    msTV.Items.EndUpdate();
  end;
end;

// ===================================================================== //
procedure TFormMain.aFileExitExecute(Sender: TObject);
begin
  Close();
end;

// ===================================================================== //
procedure TFormMain.aEditAddExecute(Sender: TObject);
begin
  if (msTV.Focused and (not msTV.IsEditing())) then
    msTV.AddNode();
end;

// ===================================================================== //
procedure TFormMain.aEditDeleteExecute(Sender: TObject);
begin
  if (msTV.Focused and (not msTV.IsEditing())) then
    msTV.DeleteNode();
end;

// ===================================================================== //
procedure TFormMain.aEditCutExecute(Sender: TObject);
begin
  if (msTV.Focused and (not msTV.IsEditing())) then
    msTV.CutNode();
end;

// ===================================================================== //
procedure TFormMain.aEditCopyExecute(Sender: TObject);
begin
  if (msTV.Focused and (not msTV.IsEditing())) then
    msTV.CopyNode();
end;

// ===================================================================== //
procedure TFormMain.aEditPasteExecute(Sender: TObject);
begin
  if (msTV.Focused and (not msTV.IsEditing())) then
    msTV.PasteNode();
end;

// ===================================================================== //
procedure TFormMain.aEditRenameExecute(Sender: TObject);
begin
  if (msTV.Focused and (not msTV.IsEditing())) then
    msTV.EditNode();
end;

// ===================================================================== //
procedure TFormMain.aEditFindExecute(Sender: TObject);
begin
  if (msTV.Focused and (not msTV.IsEditing())) then
    msTV.InitSearchParams();
end;

// ===================================================================== //
procedure TFormMain.aTools_AutoDragExecute(Sender: TObject);
begin
  aTools_AutoDrag.Checked := not aTools_AutoDrag.Checked;
  msTV.TVOptions.AutoDrag := aTools_AutoDrag.Checked;
end;

// ===================================================================== //
procedure TFormMain.aTools_AutoSortExecute(Sender: TObject);
begin
  aTools_AutoSort.Checked := not aTools_AutoSort.Checked;
  msTV.TVOptions.AutoSort := aTools_AutoSort.Checked;
end;

// ===================================================================== //
procedure TFormMain.aTools_SortAZExecute(Sender: TObject);
begin
  msTV.TVOptions.SortDirection := sdAlphabeticOrder;
end;

// ===================================================================== //
procedure TFormMain.aTools_SortZAExecute(Sender: TObject);
begin
  msTV.TVOptions.SortDirection := sdInvertedOrder;
end;

// ===================================================================== //
procedure TFormMain.aTools_ReadOnlyExecute(Sender: TObject);
begin
  aTools_ReadOnly.Checked := not aTools_ReadOnly.Checked;
  msTV.ReadOnly := aTools_ReadOnly.Checked;
end;

// ===================================================================== //
procedure TFormMain.aLangEngExecute(Sender: TObject);
var
  ID: Integer;
begin
  (Sender as TAction).Checked := true;
  ID := (Sender as TComponent).Tag;
  if (ID = 0) then // English
    aLangRus.Checked := false
  else             // Russian;
    aLangEng.Checked := false;

  // Set Language
  if (FLangID <> ID) then begin
    FLangID := ID;
    SetLanguage();
  end;
end;

// ===================================================================== //
procedure TFormMain.aHelpAboutExecute(Sender: TObject);
begin
  FormAbout := TFormAbout.Create(self);
  FormAbout.ShowModal();
  FormAbout.Release();
end;

// ===================================================================== //
procedure TFormMain.msTVProcessError(Sender: TObject; Msg: string);
begin
  CreateMessageDlg(Msg, mtWarning);
end;

// ===================================================================== //
procedure TFormMain.msTVBeforeSearchNode(Sender: TObject;
  var SearchNodeParams: TmsSearchNodeParams);
var
  Point: TPoint;
begin
  FormFind := TFormFind.Create(Self, @SearchNodeParams, FLangID);
  Point.X := ToolBar.Left + ToolBar.Width - FormFind.Width - 1;
  Point.Y := ToolBar.Top + ToolBar.Height + 1;
  Point := ClientToScreen(Point);
  FormFind.Left := Point.X;
  FormFind.Top := Point.Y;
  FormFind.ShowModal();
  FormFind.Release();
end;

// ===================================================================== //
procedure TFormMain.msTVMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Node: TmsBaseTreeNode;
  Point: TPoint;
begin
  if (Button = mbRight) then begin
    Node := msTV.GetNodeAt(X, Y);
    if (Node <> nil) then begin
      msTV.Selected := Node;
      Point.X := X;
      Point.Y := Y;
      Point := msTV.ClientToScreen(Point);
      msTV.PopupMenu.Popup(Point.X, Point.Y);
    end;
  end;
end;

procedure TFormMain.ActionListExecute(Action: TBasicAction;
  var Handled: Boolean);
begin
{
const
  AltMask = $20000000;
  CtrlMask = $10000000;
  ShiftMask = $08000000;
var
  Msg: TWMKey;
  Key: Word;
  KeyData: Longint;
  Shift: TShiftState;
begin
  if ( (Action = aEditInsert) or (Action = aEditDelete) or
       (Action = aEditCut) or (Action = aEditCopy) or
       (Action = aEditPaste) or (Action = aEditRename) or
       (Action = aEditFind) )
  then begin
    ShortCutToKey((Action as TAction).ShortCut, Key, Shift);
    KeyData := 0;
    if (ssShift in Shift) then
      KeyData := CtrlMask;
    Msg.Msg := WM_KEYDOWN;
    Msg.CharCode := Key;
    Msg.KeyData := KeyData;
    msTV.Dispatch(Msg);
  end;
  }
end;

end.
