unit UFormMessage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ImgList;

type
  TFormMessage = class(TForm)
    btnOK: TButton;
    imgIcon: TImage;
    labelMessage: TLabel;
    Bevel1: TBevel;
    imgListIcons: TImageList;
    procedure FormCreate(Sender: TObject);
  private
    FMsg: string;
    FnIcon: Integer;
  public
    constructor Create(AOwner: TComponent; Msg: string; nIcon: Integer); reintroduce;
  end;

var
  FormMessage: TFormMessage;

procedure CreateMessageDlg(Msg: string; DlgType: TMsgDlgType);

implementation

{$R *.dfm}

// ===================================================================== //
procedure CreateMessageDlg(Msg: string; DlgType: TMsgDlgType);
var
  FormMessage: TFormMessage;
  nIcon: Integer;
begin
  case (DlgType) of
    mtInformation : nIcon := 0;
    mtWarning : nIcon := 1;
    mtError : nIcon := 2;
    else nIcon := -1;
  end;
  FormMessage := TFormMessage.Create(Application, Msg, nIcon);
  FormMessage.ShowModal();
end;

// ===================================================================== //
constructor TFormMessage.Create(AOwner: TComponent; Msg: string; nIcon: Integer);
begin
  inherited Create(AOwner);

  FMsg := Msg;
  FnIcon := nIcon;
end;

// ===================================================================== //
procedure TFormMessage.FormCreate(Sender: TObject);
begin
  labelMessage.Caption := FMsg;
  if (FnIcon <> -1) then
    imgListIcons.GetBitmap(FnIcon, imgIcon.Picture.Bitmap);
end;

end.
